package pipe.gui;

import pipe.dataLayer.*;
import javax.swing.*;
import java.awt.Event.*;
import java.awt.event.*;
import java.util.*;

public class Animator implements ActionListener, Constants{

  GuiFrame animatorAppGui;
  DataLayer pnmlOriginal;
  DataLayer pnmlCopy;
  GuiView animatorAppView;
  CreateGui animatortheApp;
  Transition lastTransition;
  Transition nextTransition;
  private ArrayList firedTransitions = null;
  private static int count= 0;
  private static int forwardcount =0;
  private static int totalcount =0 ;
  private static int clock = 2000;

  public Animator(){
  }

  public Animator(CreateGui theApp,GuiFrame appGui, GuiView appView, DataLayer original){

    //animatorAppGui = appGui;
    //animatorAppView = appView;
    animatortheApp = theApp;
    //pnmlOriginal = original;
    firedTransitions = new ArrayList();


  }

    /* highlights enabled transitions*/
  public void highlightEnabledTransitions(){


    Iterator transitionIterator =animatortheApp.currentPNMLData().returnTransitions();
    while(transitionIterator.hasNext()){

      Transition tempTransition =(Transition) transitionIterator.next();

      if(tempTransition.isEnabled(true)==true){

        animatortheApp.currentPNMLData().notifyObservers();
        tempTransition.repaint();

      }
    }
  }

    /* called during animation to unhighlight previously highlighted transitions*/
  public void unhighlightDisabledTransitions(){

    Iterator transitionIterator = animatortheApp.currentPNMLData().returnTransitions();
    while(transitionIterator.hasNext()){

      Transition tempTransition =(Transition) transitionIterator.next();

      if(tempTransition.isEnabled(true)==false){

        animatortheApp.currentPNMLData().notifyObservers();
        tempTransition.repaint();
      }
    }
  }

    /* called at end of animation and resets all Transitions to false and unhighlighted*/
  public void disableTransitions(){
    Iterator transitionIterator = animatortheApp.currentPNMLData().returnTransitions();
    while(transitionIterator.hasNext()){
      Transition tempTransition =(Transition) transitionIterator.next();
      tempTransition.setEnabledFalse();
      animatortheApp.currentPNMLData().notifyObservers();
      tempTransition.repaint();
    }
  }

    /* stores model at start of animation*/
  public void storeModel(){
    animatortheApp.currentPNMLData().storeState();
    //animatortheApp.getModel().storeState();
  }

    /*restores model at end of animation and sets all transitions to false and unhighlighted*/
  public void restoreModel(){
    animatortheApp.currentPNMLData().restoreState();
    //animatortheApp.getModel().restoreState();
    disableTransitions();
  }

  public void startRandomFiring(int numberSequences){
    RandomFiringThread firing = new RandomFiringThread(numberSequences);
//    firing.setPriority(Thread.currentThread().getPriority() - 2);
    firing.run();
  }

    /* fires transitions for a certain number of sequences as determined by the user */
  class RandomFiringThread extends Thread {
    int numberSequences = 1;

    public RandomFiringThread(int number_of_sequences) {
      numberSequences = number_of_sequences;
    }

    public void run() {

      for(int i = 1; i <= numberSequences; i++){

//        Thread.yield();
//        try { Thread.sleep(5000); } catch (Exception e) { }


        animatortheApp.currentPNMLData().setEnabledTransitions();
        animatortheApp.currentPNMLData().fireRandomTransition();
        animatortheApp.currentPNMLData().setEnabledTransitions();

        unhighlightDisabledTransitions();
        highlightEnabledTransitions();

      }

    }
  }






    /*steps back through previously fired transitions*/
  public void stepBack(){

    if(count>0){
      lastTransition = (Transition)firedTransitions.get(count-1);
      count--;
      animatortheApp.currentPNMLData().fireTransitionBackwards(lastTransition);
      //animatortheApp.getModel().fireTransitionBackwards(lastTransition);

      animatortheApp.currentPNMLData().setEnabledTransitions();
      //animatortheApp.getModel().setEnabledTransitions();
      unhighlightDisabledTransitions();
      highlightEnabledTransitions();
    }
    else return;
  }

    /* steps forward through previously fired transitions*/
  public void stepForward(){
    if(count < firedTransitions.size()){
      nextTransition = (Transition)firedTransitions.get(count);
      count++;
      animatortheApp.currentPNMLData().fireTransition(nextTransition);
      //animatortheApp.getModel().fireTransition(nextTransition);
      animatortheApp.currentPNMLData().setEnabledTransitions();
      //animatortheApp.getModel().setEnabledTransitions();
      unhighlightDisabledTransitions();
      highlightEnabledTransitions();
    }
    return;
  }

    /* stores transitions that has just been fired in array so that it can be accessed during backwards and forwards stepping*/
  public void passTransition(Transition last){

    firedTransitions.add((Object)last);
    count++;
    totalcount++;

  }

  public void actionPerformed(ActionEvent e){
  }
}







